import requests # 网页爬取库
from bs4 import BeautifulSoup # HTML、XML等架构分析库

num=0 # 为文本文档编号，预先设置“num”变量

# 设置爬取函数，输入网址，返回网址HTML源码
def soup(url):
    r = requests.get(url)
    r.encoding="utf-8"
    demo = r.text
    soup = BeautifulSoup(demo, "html.parser")
    return soup

for number in range(1,501): # 循环翻页（1-500页）

    # 在一级网页上找到每条新闻的二级网页超链接，访问二级网页，爬取新闻内容，并存储于独立文本文档中
    url="https://www.chinadaily.com.cn/china/59b8d010a3108c54ed7dfc23/page_{}.html".format(number)
    page_1=soup(url)
    for e_1 in page_1.find_all("h4"): # 定位到标题标签（“<h4>”）
        for e_2 in e_1.find_all("a"):
            url_2="https:{}".format(str(e_2["href"])) # 获取二级网页超链接（“<a href="">”）

            # 访问二级网页
            page_2=soup(url_2)

            # 爬取新闻内容
            content = ""
            for e_3 in page_2.find_all("p"): # 找到段落（paragraph）的标签“p”并提取新闻内容
                content+="{}\n".format(str(e_3.text))

            # 将爬取的新闻内容存储于独立文本文档中
            num+=1
            num_1="{:0>3}".format(num)
            fileout=open("CNNews{}.txt".format(num_1),"w",encoding="utf8") # 创建文本文档，并以如“CNNews001.txt”的形式命名
            fileout.write(content) # 将爬取内容写入独立文本文档
            print(content)