import requests # 网页爬取库
from bs4 import BeautifulSoup # HTML、XML等格式架构分析库
import re # 正则表达式库
from time import sleep # 引入系统休眠
num=0 # 为文本文档编号，预先设置“num”变量

# 设置Cookies，获取方式请参考书目
headers={'Cookie':'SINAGLOBAL=4905712127214.925.1680413746985; SCF=ApU1P7Bb7ucJaSjB4uyENjR8scQdW5HV94jttpfBmkgrK2X3k69tPkKpzuYsMFM_AIp4Hx53WlYkBuQp_sKi61c.; UOR=,,login.sina.com.cn; _s_tentry=-; Apache=683353326939.2089.1711465921294; XSRF-TOKEN=Y8wzj65IMjVmgKoJqqFi7Ypz; ULV=1711465921336:8:2:2:683353326939.2089.1711465921294:1711453878991; ALF=1714057908; SUB=_2A25LBpXkDeRhGeFK41cT-S_PyzSIHXVofZcsrDV8PUJbkNANLU7tkW1NQs831x7s09hOXT9mhT7hlWHj3QF3lksd; SUBP=0033WrSXqPxfM725Ws9jqgMF55529P9D9WF_-2QyRD6njCA5FcvA.mQZ5JpX5KzhUgL.FoMX1h-E1K20ehn2dJLoI0qLxKMLBKnL12zLxKqLBo5L1K2LxKnL1hnL1-eLxKML1-2L1hBLxK-LBo5L12qLxK-LB-BL1K5t; WBPSESS=mrmGZPu571k1faBDBsXvvVXQ5rH1vK6zpHOrJCcnrE2YcSxl476wciZVNduIpYCmdHyNcPqM1GRZazG7Ky4I0tnb_L1xWuwltlyjHc0W3yvr47JIWtZR0Tg_hkgiJgJh9fng78ClkVjHcufI8f_aJA=='}

# 设置带有Cookies的爬取函数，输入网址，返回网址HTML源码
def soup(url):
    r = requests.get(url,headers=headers)
    r.encoding="utf-8"
    demo = r.text
    soup = BeautifulSoup(demo, "html.parser")
    return soup

for number in range(1,50): # 循环翻页（1-50页）

    sleep(3) # 系统休眠3秒，防止微博反爬取

    url="https://s.weibo.com/weibo?q=国乒&page={}".format(number)
    page_1=soup(url)

    for e_1 in page_1.find_all("div", attrs={"class": "content"}): # 找到每一条微博

        user=""
        user_from=""
        content=""

        # 爬取博主用户名
        for e_2 in e_1.find_all("div",attrs={"class": "info"}):
            for e_3 in e_2.find_all("div",style=True):
                user=e_3.text

        # 爬取博文元数据
        for e_2 in e_1.find_all("div",attrs={"class": "from"}):
            user_from=e_2.text

        # 爬取博文
        e_5=e_1.find_all("p",attrs={"node-type": "feed_list_content"})
        content=e_5[0].text # 爬取博文（展开全文前）
        if "展开c" in str(content):
            for e_2 in e_1.find_all("p",attrs={"node-type": "feed_list_content_full"}):
                content=e_2.text # 爬取博文（展开全文后）
                content=str(content).replace("收起d","")

        # 将博主用户名、博文元数据、博文内容清洗后以XML格式，以“WeiboCNTT001.txt”的命名形式，存入独立的文本文档中
        user_1=str(re.sub("\s+"," ",str(user))).strip()
        user_from_1=str(re.sub("\s+"," ",str(user_from))).strip()
        content_1=str(re.sub("\s+"," ",str(content))).strip()
        weibo="<seg>\n<user>{}</user>\n<from>{}</from>\n<content>{}</content>\n</seg>\n\n".format(user_1,user_from_1,content_1)

        num += 1
        num_1 = "{:0>3}".format(num)
        fileout = open("WeiboCNTT{}.txt".format(num_1), "w", encoding="utf8")
        fileout.write(weibo)
        print(weibo)